// ******************************************************************
// * TITLE: cpanel.c                                                *
// * AUTHOR: Steven Winig                                           *
// * DATE: April 30, 1993                                           *
// * Purpose: Create display Control Panel for main screen          *
// ******************************************************************


#include "window.h"
#include "cpanel.h"
#include "button.h"
#include "scrnobj.h"
#include "ui.h"

#include <alloc.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>



CPanelWindow::CPanelWindow (void)
{
  XDim = CPanelXDim; YDim = CPanelYDim;
  CliX1 = CliY1 = CliX2 = CliY2 = 0;
  TX1 = TY1 = TX2 = TY2 = 0;
  BorderColor = RED;
  BkColor = LIGHTGRAY;
  TitleColor = WHITE;
  Title = new char[20];
  strcpy (Title, "Control Panel");
  ClientD = TitleD = NULL;
  Drawn = False;
}

void CPanelWindow::Init (Display *d, int x, int y)
{
  Disp = d;
  X = x;  Y = y;

  CalcBorder ();
  if (Title)
  {
    CalcTitle ();
    TitleD = new Display (Disp, TX1, TY1, TX2, TY2);
    assert (TitleD != 0);
    TitleD->SetBkColor (BorderColor);
    TitleD->SetTextJustify (CENTER_TEXT, TOP_TEXT);
    TitleD->SetTextStyle (TitleFont, HORIZ_DIR, TitleFontSize);
    TitleD->SetColor (TitleColor);
  }
  ClientD = new Display (Disp, CliX1, CliY1, CliX2, CliY2);
  assert (ClientD != 0);
  ClientD->SetBkColor (BkColor);

  PushButton *pb[Num_Buttons_In_CPanel];
  pb[3] = new PushButton ("Legal Stops", BLUE, ID_LEGAL);
  pb[1] = new PushButton ("Refresh", BLUE, ID_REFRESH, pb[3]->GetXDim(), pb[3]->GetYDim());
  pb[2] = new PushButton ("Quit", BLUE, ID_QUIT);
  pb[0] = new PushButton ("Spy", BLUE, ID_SPY, pb[2]->GetXDim(), pb[2]->GetYDim());
  for (int i=0; i < Num_Buttons_In_CPanel; i++)
     assert (pb[i] != NULL);

  ClientD -> Add(pb[0],25, 2);
  ClientD -> Add(pb[1],25, pb[0]->GetYDim()+5);
  ClientD -> Add(pb[3],ClientD->GetMaxX()-pb[3]->GetXDim()-25, 2);
  ClientD -> Add(pb[2],ClientD->GetMaxX()-pb[2]->GetXDim()-25
		,pb[0]->GetYDim()+5);
}


Message CPanelWindow::Dispatch (Message& msg)
{
  if (ClientD)
    return ClientD->Dispatch (msg);	// Dispatch messages to client area
  else
    return NullMsg;
}

