/*************************************************************************
* 	FILE:	display.c
*	AUTHOR: CALeague
*	DATE:	25 April 1993
*	PURPOSE:
*	  A display is a viewport which can contain "screen objects",
*	  such as windows and buttons.
**************************************************************************/

#include "display.h"


void Display::Add (ScrnObj *a, int x, int y)
{
  list.Append (a);
  a->Init (this, x, y);
}


void Display::Draw (void)
{
  if (list.Reset ())
    do {
      list.GetCurrent()->Draw ();
    } while (list.Next ());
}

void Display::Erase (void)
{
  if (list.Reset ())
    do {
      list.GetCurrent()->Erase ();
    } while (list.Next ());
}


Message Display::Dispatch (Message& msg)
{
  if (! list.Reset ())	    	// if list is empty
    return NullMsg;	        //   return
  else
  {

    Message m = msg;
    switch (msg.origin)
    {
      case MouseMsg:			// Do d1,d2 represent coordinates?
	m.d1 = TransX (msg.d1);	 	// Translate them.
	m.d2 = TransY (msg.d2);
//	if (!InBounds (m.d1, m.d2))
//	  return NullMsg;
	break;
    }

    Message ret;
    do {
      ret = list.GetCurrent()->Dispatch (m);	// pass to next scrnobj
    } while ((ret == NullMsg) && list.Next ());

    return ret;
  }
}


