/*************************************************************************
 *
 *	AUTHOR:	Wilson Tham
 *
 *	TITLE:	group.h
 *
 *	DATE:	April 28, 1993
 *
 *	PURPOSE:  Declaration of group class for checkboxes.
 *
 *************************************************************************/

#include <stdlib.h>
#include "typedefs.h"
#include "scrnobj.h"
#include "viewport.h"
#include "display.h"
#include "messages.h"
#include "checkbox.h"
#include "nodes.h"

class Group:public ScrnObj{
	CheckBox **Boxes;
protected:
	int NumObj, CurrentObj, CurrentId, IdNum, Default;
public:
	Group			()
		{};
	Group			(int, int);
	~Group			();
	void Add			(CheckBox *, int, int);
	Message Dispatch	(Message &);
	void Init			(Display *d, int x, int y)
		{Disp=d, X=x, Y=y;}
	void Draw			();
	void Erase		();
	void DisableBox		(int);
	void EnableBox 		(int);
protected:
	void off_last		();
	int  id_to_int		(int);
private:
	void disable_proc	();
	void enable_proc	();
};

typedef CheckBox * CheckBoxP;

inline Group::Group(int numobj, int idnum)
	{NumObj=numobj; CurrentObj=0; Default=0; CurrentId=0; IdNum=idnum;
	 Boxes = (CheckBox **) calloc (NumObj, sizeof (CheckBox*));}

inline void Group::off_last()
	{Boxes[CurrentId]->ChangeStatus(Off);}

