/*************************************************************************
* 	FILE:	keybd.c
*	AUTHOR: CALeague
*	DATE:	18 April 1993
*	PURPOSE:
*	  Keybd class serves as an interface between the UI and the
*	  keyboard.  It generates messages based on keyboard events
*	  containing character codes and scan codes.
**************************************************************************/


#include "keybd.h"
#include <conio.h>


Message Keybd::Event (void)
{
  if (! kbhit())
    return NullMsg;
  else
  {
    Message msg (KeyMsg, KeyPressed, getch ());
    if (msg.d1 == 0)
      msg.d2 = getch ();
    return msg;
  }
}


Message Keybd::WaitForAnyEvent (void)
{
  Message msg;

  do msg = Event();
  while (msg.code == Idle);

  return msg;
}


Message Keybd::WaitForEvent (Message& msg)
{
  Message try;

  do try = Event ();
  while (try != msg);

  return try;
}


void Keybd::Flush (void)
{
  Message m;
  do {
    m = Event ();
  } while (m != NullMsg);
}



