/*************************************************************************
* 	FILE:	msgwin.c
*	AUTHOR: CALeague
*	DATE:	26 April 1993
*	PURPOSE:
*	  Creates a pop-up message window with an OK button and returns
*	  a message corresponding to that button being pressed.
**************************************************************************/

#include "msgwin.h"
#include "textwin.h"
#include "button.h"

const int Margin = 5;

Message MessageWin (int bc, int bkc, char* t, int tc, char **txt, int txtc)
{
  TextWin *w;
  PushButton *b;

  b = new PushButton (" Ok ", BLACK, 0x01);

  w = new TextWin (b->GetXDim() + (Margin*2), b->GetYDim() + (Margin*2),
		  bc, bkc, t, tc, txt, txtc);
  int wx = (theDisplay.GetMaxX() - w->GetXDim()) / 2;
  int wy = (theDisplay.GetMaxY() - w->GetYDim()) / 2;
  w->Init (&theDisplay, wx, wy);

  int bx = (w->Client().GetMaxX() - b->GetXDim()) / 2;
  int by = (w->Client().GetMaxY() - b->GetYDim()) - Margin;
  w->Client().Add (b, bx, by);

  w->Draw ();

  Mouse.Flush ();
  Message m;
  do {
    m = w->Client().Dispatch (Mouse.Event ());
  } while (m.code != ButtonPress);

  delete w;
  return m;
}

