/*************************************************************************
* 	FILE:	playrwin.c
*	AUTHOR: CALeague/SRWinig
*	DATE:	30 April 1993/1 May 1993
*	PURPOSE:
*	  Declares the Player Information window, a component of the UI.
**************************************************************************/

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include "playrwin.h"
#include "map.h"


PlayerWindow::PlayerWindow (void)
{
  XDim = PlayerWinXDim;  YDim = PlayerWinYDim;
  CliX1 = CliY1 = CliX2 = CliY2 = 0;
  TX1 = TY1 = TX2 = TY2 = 0;
  BorderColor = RED;
  BkColor = LIGHTGRAY;
  TitleColor = WHITE;
  Title = new char [strlen (PlayerWinTitle)];
  assert (Title != 0);
  strcpy (Title, PlayerWinTitle);
  ClientD = TitleD = NULL;
  Drawn = False;
  Name = "Welcome to Scotland Yard";
  Tokens[Bus] = 0;
  Tokens[Taxi] = 0;
  Tokens[Subway] = 0;
  RoundNum = 0;
  Address = 0;
}


void PlayerWindow::DrawInfo (void)
{
  char AddressBuf[21], buffer[80];
  char bus[20], taxi[20], subway[20], round[20];

  ClientD->SetColor (BLACK);
  ClientD->SetTextStyle (GOTHIC_FONT, HORIZ_DIR, 1);
  ClientD->SetTextJustify (LEFT_TEXT, TOP_TEXT);
  ClientD->OutTextXY (5, 5, Name);
  ClientD->SetTextStyle (DEFAULT_FONT, HORIZ_DIR, 1);

  if ((strcmp (Name, "Welcome to Scotland Yard")) == 0)
    {ClientD->OutTextXY (5, 40, "Written by THE MAD HAMSTERS");}
  else
  if (Tokens[Bus]!=Invalid) {
    sprintf (bus, "Bus %d", Tokens[Bus]);
    ClientD->OutTextXY (5, 40, bus);
    sprintf (taxi, "Taxi %d", Tokens[Taxi]);
    ClientD->OutTextXY (65, 40, taxi);
    sprintf (subway, "Subway %d", Tokens[Subway]);
    ClientD->OutTextXY (133, 40, subway);
    sprintf (round, "Round: %d", RoundNum+1);
    ClientD->OutTextXY (133, 5, round);

    if(theMap.get_name(Address)) {
      sprintf(buffer, "%-20s", theMap.get_name(Address));
      ClientD->OutTextXY (5, 30, buffer);
    }
  }
  else
  {
    ClientD->OutTextXY (5,40, "says, 'Bloody Wanker'!!");
    sprintf (round, "Round: %d", RoundNum+1);
    ClientD->OutTextXY (133, 5, round);
  }

}


void PlayerWindow::Draw (void)
{
  if (!Drawn)
  {
    assert (Disp != NULL);
    Disp->FastDraw ();
    PrepScreen ();
    DrawBorder ();
    if (TitleD)
      DrawTitle ();
    ClientD->Clear ();
    ClientD->Draw ();
    DrawInfo ();
    Disp->Done ();
    Drawn = True;
  }
}


void PlayerWindow::Update (Player& P, int roundnum)
{
  Name = P.GetName ();
  Address = P.GetPosition();
  Tokens [Taxi] = P.NumTokens (Taxi);
  Tokens [Bus] = P.NumTokens (Bus);
  Tokens [Subway] = P.NumTokens (Subway);
  RoundNum=roundnum;
  Clear();
  DrawInfo();
}


