/**********************************************************************
*	FILE:	spywin.c
*	AUTHOR: SRWinig
*	DATE:	May 1, 1993
*	PURPOSE:
*	  Houses the rest of the user interface
***********************************************************************/

#include "ui.h"

#include <stdio.h>
#include <assert.h>
#include "msgwin.h"
#include "popupwin.h"
#include "keybd.h"
#include "button.h"
#include "moves.h"



void UserInterface::ShowSpyMoves (MoveList& moves)
{
  PopUpWin *SMWindow = new PopUpWin(200, 170, BLUE, WHITE, "Spy Moves", WHITE);
  assert (SMWindow != NULL);
  SMWindow->Init(&theDisplay, 100, 100);
  PushButton *pb = new PushButton (" OK ", BLUE, 0xF0);
  assert (pb != NULL);
  SMWindow->Client().Add (pb, (SMWindow->Client().GetMaxX()/2) - (pb->GetXDim()/2), SMWindow->Client().GetMaxY() - pb->GetYDim() - 5);
  SMWindow->Draw();
  SMWindow->Client().SetColor (BLACK);

  Move *current;
  char info[20];
  moves.Reset();
  int i = 1,AddlX = 0, y = 0;
  if (moves.Reset())
  {
    do {
      current = moves.GetCurrent();
      if (current->Trans==SubwayMask)
	 {sprintf (info, "%2d: Subway", i);}
      else
      if (current->Trans==TaxiMask)
	 {sprintf (info, "%2d: Taxi", i);}
      else
      if (current->Trans==BusMask)
	 {sprintf (info, "%2d: Bus", i);}
      if (i == 13)
	{AddlX = 100; // puts text in second column
	 y = 0;}      // puts text in first row
      SMWindow->Client().OutTextXY(5 + AddlX, 5 + (8*y), info);
      i++;
      y++;
    } while (moves.Next());
  }
  Message m;
  do
  {
    m = SMWindow->Client().Dispatch (Mouse.Event());
  } while (m.code != ButtonPress);
  delete SMWindow;
}

