/*************************************************************************
 *
 *	AUTHOR:	Wilson Tham
 *
 *	TITLE:	trans.h
 *
 *	DATE:	May 1, 1993
 *
 *	PURPOSE:  Declaration of group class for checkboxes.
 *
 *************************************************************************/

#include <assert.h>
#include "ui.h"
#include "checkbox.h"
#include "group.h"
#include "typedefs.h"
#include "button.h"
#include "popupwin.h"

const int TWinXDim = 200;
const int TWinYDim = 150;

int UserInterface::TransPop(byte bv, int color)
{
	int Mode=0, i=0;

	// CREATE WINDOW
	PopUpWin *w = new PopUpWin(TWinXDim, TWinYDim, RED, WHITE,
		"Mode of Transportation", WHITE);
	assert(w !=NULL);
	w->Init(&theDisplay, 640/2-TWinXDim/2, 480/2-TWinYDim/2);

	// CREATE CHECKBOXES
	CheckBox *ch[3];
	ch[0] = new CheckBox("Taxi", BLACK, color, 1000, Square);
	ch[1] = new CheckBox("Bus", BLACK, color, 1001, Square);
	ch[2] = new CheckBox("Subway", BLACK, color, 1002, Square);
	for(i=0; i<3; i++)
		assert(ch[i] !=NULL);

	// CREATE PUSHBUTTONS
	PushButton *pb[2];
	pb[1] = new PushButton ("Cancel", BLUE, 901);
	pb[0] = new PushButton ("Done", BLUE, 900, pb[1]->GetXDim(), pb[1]->GetYDim());
	for(i=0; i<2; i++)
		assert(pb[i] !=NULL);

	//CREATE GROUP AND ADD CHECKBOXES
	Group *modes = new Group(3, 1000);
		assert(modes !=NULL);
	w->Client().Add(modes, 0, 0);
	for(i=0; i<3; i++)
		modes->Add(ch[i], 20, 20+(i*20));

	//ADD PUSHBUTTONS AND GROUP TO POP-UP WINDOW
	w->Client().Add(pb[0], w->Client().GetMaxX()/2-65, w->Client().GetMaxY()-pb[0]->GetYDim()-5);
	w->Client().Add(pb[1], w->Client().GetMaxX()/2+5, w->Client().GetMaxY()-pb[1]->GetYDim()-5);

	//DRAW POP-UP WINDOW
	w->Draw();

	int def = 0;
	if(!(bv & TaxiMask))
		modes->DisableBox(1000);
	else
		def = 1000;
	if(!(bv & BusMask))
		modes->DisableBox(1001);
	else if (!def) def = 1001;
	if(!(bv & SubwayMask))
		modes->DisableBox(1002);
	else if (!def) def = 1002;

	Mode=def-1000;
	Message DoneMsg(ButtonMsg, ButtonPress, 900), m;
	Message CancelMsg(ButtonMsg, ButtonPress, 901);
	do {
		m=w->Dispatch(Mouse.Event());
		if((m.origin==ButtonMsg)&&(m.code==Status)&&(m.d2)) //Checkbox on
			Mode=m.d1-1000;
	} while((m != DoneMsg) && (m != CancelMsg));

	delete w;

	if(m==CancelMsg)
		return (-1);
	else
		return Mode;
}
