/**********************************************************************
*	FILE:	video.c
*	AUTHOR:	Christopher League
*	DATE:	18 April 1993
*	PURPOSE:
*	  Contains the device class Video, which initializes BGI
*	  graphics.
***********************************************************************/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "video.h"

/**********************************************************************
*	Constructor
***********************************************************************/

Video::Video (VideoModes mode) : Mode (mode)
{
  int gdriver, gmode, err;
  void far *driver;

  switch (Mode)			// Check the video mode
  {
    case VGAHi:
      gdriver = VGA;
      gmode   = VGAHI;
      break;
    default:
      gdriver = DETECT;
  };

#ifdef LINK_BGI
  switch (Mode)
  {
    case VGAHi:
      driver = EGAVGA_driver_far;
      break;
  }

  err = registerfarbgidriver(driver);	// Register the driver (linked in)
  if (err < 0)
  {
    printf("Graphics error: %s\n", grapherrormsg(err));
    printf("Press any key to halt:\n");
    getch();
    exit(1); /* terminate with an error code */
  }
#endif
#ifdef LINK_FONT
  registerfarbgifont (triplex_font_far);	// Register linked fonts
  registerfarbgifont (gothic_font_far);
  registerfarbgifont (small_font_far);
  registerfarbgifont (sansserif_font_far);
#endif

  initgraph(&gdriver, &gmode, "");	// Initialize graphics
  err = graphresult();
  if (err != grOk)  /* an error occurred */
  {
    printf("Graphics error: %s\n", grapherrormsg(err));
    printf("Press any key to halt:\n");
    getch();
    exit(1); /* terminate with an error code */
  }

}

/**********************************************************************
*	Destructor
***********************************************************************/

Video::~Video (void)
{
  closegraph ();
}


